#include <stdio.h>

typedef unsigned char byte;
typedef unsigned short int word;
typedef unsigned long int dword;

typedef signed char sbyte;
typedef signed short int sword;
typedef signed long int sdword;


#pragma aux vesainit modify [eax ebx ecx edx esi edi];
#pragma aux retmodeinfo modify [eax ebx ecx edx esi edi];
#pragma aux setmode modify [eax ebx ecx edx esi edi];
#pragma aux llama_flip modify [eax ebx ecx edx];
#pragma aux llama_flip_wait modify [eax ebx ecx edx];

#pragma aux llama_okseebye modify [ax bx cx dx];

extern void vesainit(void);
extern void retmodeinfo(void);
extern void setmode(void);
extern void llama_flip(void);
extern void llama_flip_wait(void);


extern word mem64;
extern dword bytes_per_page;
extern word modes[256];
extern dword vesaerror;

byte req_bpp;
word req_xres,req_yres;
word have_a_mode;
byte num_pages;



dword llama_wants(word x,word y,byte c){
    word f=0;
    vesainit();if(vesaerror!=0)goto enditnow;
    if( (x*y*(c/8)*2)>(mem64*64*1024) ){printf("Not enough memory for 2 pages in this mode!");vesaerror=1;goto enditnow;}
    bytes_per_page=x*y*(c/8);
    morestuff:
    have_a_mode=modes[f];
    if(have_a_mode==0xffff){vesaerror=666;goto enditnow;}
    retmodeinfo();
    if(req_xres==x&&req_yres==y&&req_bpp==c)
	{setmode();goto enditnow;}
    f++;goto morestuff;
    enditnow:
    if (vesaerror==666)printf("Can't find a matching mode!\n\t");
    return vesaerror;
}

dword llama_wonders(){
    word f=0;
    vesainit();if(vesaerror!=0)goto enditnow2;
    morestuff2:
    have_a_mode=modes[f];
    if(have_a_mode==0xffff)goto enditnow2;
    retmodeinfo();
    if(f==0)printf("The llama can sense the following modes...\n\t\n\t");
    printf("%X = %d by %d with %d bit colour. Highest page=%d.\n\t",modes[f],req_xres,req_yres,req_bpp,num_pages); 
    f++;goto morestuff2;
    enditnow2:
    printf("\n\tHai!");
    return vesaerror;
}
