simrealpass struct
    sedi dd 0
    sesi dd 0
    sebp dd 0
    sreserved dd 0
    sebx dd 0
    sedx dd 0
    secx dd 0
    seax dd 0
    sflags dw 0
    ses dw 0
    sds dw 0
    sfs dw 0
    sgs dw 0
    sip_ignored dw 0
    scs_ignored dw 0
    ssp dw 0
    sss dw 0
simrealpass ends



infoblok struct 
  sig db 'VBE2'           ; VBE Signature
  vbever dw 0           ; VBE Version
  text_ptr1 dd 0         ; Pointer to OEM String
  Capabilities dd 0         ; Capabilities of graphics cont.
  vidmodes dd 0             ; Pointer to Video Mode List 
  totmem dw 0               ; Number of 64kb memory blocks
  softver dw 0       ; VBE implementation Software revision
  text_ptr2 dd 0     ; Pointer to Vendor Name String
  text_ptr3 dd 0    ; Pointer to Product Name String
  text_ptr4 dd 0     ; Pointer to Product Revision String
  _Reserved_ db 222 dup (0)   ; Reserved for VBE implementation scratch area
  OemData db 256 dup (0)            ; Data Area for OEM Strings
infoblok ends


modeblok struct 
  modeattr dw 0     ; mode attributes
  WinAAttributes db 0     ; window A attributes
  WinBAttributes db 0     ; window B attributes
  WinGranularity dw 0     ; window granularity
  WinSize dw 0            ; window size
  WinASegment dw 0        ; window A start segment
  WinBSegment dw 0        ; window B start segment
  WinFuncPtr dd 0         ; pointer to window function
  BytesPerScanLine dw 0   ; bytes per scan line
  xres dw 0        ; horizontal resolution in pixels or chars
  yres dw 0        ; vertical resolution in pixels or chars
  XCharSize db 0          ; character cell width in pixels
  YCharSize db 0          ; character cell height in pixels
  NumberOfPlanes db 0     ; number of memory planes
  bpp db 0       ; bits per pixel
  NumberOfBanks db 0      ; number of banks
  MemoryModel db 0        ; memory model type
  BankSize db 0           ; bank size in KB
  numpages db 0           ; number of image pages
  _Reserved db 0          ; reserved for page function
  RedMaskSize db 0        ; size of direct color red mask in bits
  RedFieldPosition db 0   ; bit position of lsb of red mask
  GreenMaskSize db 0      ; size of direct color green mask in bits
  GreenFieldPosition db 0 ; bit position of lsb of green mask
  BlueMaskSize db 0       ; size of direct color blue mask in bits
  BlueFieldPosition db 0  ; bit position of lsb of blue mask
  RsvdMaskSize db 0       ; size of direct color reserved mask in bits
  RsvdFieldPosition db 0  ; bit position of lsb of reserved mask
  DirectColorModeInfo db 0; direct color mode attributes
  fiz_base_point dd 0        ; physical address for flat frame buffer
  offscreen dd 0 ; pointer to start of off screen memory
  OffScreenMemSize dw 0   ; amount of off screen memory in 1k units
  __Reserved db 206 dup (0)    ; remainder of ModeInfo
modeblok ends
